<html>
	<head>
		<meta charset="utf-8"/>
		<script src="wasm_exec.js"></script>

	</head>
	<body>
		<h1>WASM Experiments</h1>
		<script>
      
			if (!WebAssembly.instantiateStreaming) { // polyfill
				WebAssembly.instantiateStreaming = async (resp, importObject) => {
					const source = await (await resp).arrayBuffer()
					return await WebAssembly.instantiate(source, importObject)
				}
			}

      function loadWasm(path) {
        const go = new Go()
        return new Promise((resolve, reject) => {
          WebAssembly.instantiateStreaming(fetch(path), go.importObject)
          .then(result => {
            go.run(result.instance)
            resolve(result)
          })
          .catch(error => {
            reject(error)
          })
        })
      }
      
      // Call the promise
			loadWasm("main.wasm").then(result => {

        let jsonData = Hello({firstName: "Bob", lastName: "Morane"})
        
        document.querySelector("h1").innerHTML = JSON.stringify(jsonData)
        
			}).catch(error => {
        console.log("ouch", error)
      }) 
      
		</script>
	</body>
</html>